import greenfoot.*;

public class Invader extends Actor
{
    public Invader()
    {
        GreenfootImage image = new GreenfootImage(32, 20);
        image.fill();
        setImage(image);
    }
    
    public boolean moveInvader(int dir)
    {
        setLocation(getX()+dir*5, getY());
        return getX() < 20 || getX() > getWorld().getWidth()-20;
    }
    
    public void act()
    {
        Actor player = getOneIntersectingObject(Player.class);
        if (player != null) getWorld().removeObject(player);
        if (Greenfoot.getRandomNumber(200) == 0) shoot();
    }
    
    private void shoot()
    {
        int dist = getWorld().getHeight()-getY();
        Feeler feeler = new Feeler();
        feeler.setImage(new GreenfootImage(1, dist));
        getWorld().addObject(feeler, getX(), getY()+dist/2+30);
        int count = feeler.invaderCount;
        getWorld().removeObject(feeler);
        if (count == 0)
        {
            Bullet bullet = new Bullet();
            bullet.setRotation(90);
            getWorld().addObject(bullet, getX(), getY());
            bullet.move(15);
        }        
    }
    
    public class Feeler extends Actor
    {
        public int invaderCount;
        
        public void addedToWorld(World w)
        {
            invaderCount = getIntersectingObjects(Invader.class).size();
        }
    }
}